//+------------------------------------------------------------------+
//|                                                        Vidya.mq4 |
//|                                  Copyright  2006, Amritend Maji |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Amritendu Maji"
#property link      "None"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 1
#property  indicator_color1  Salmon
#property  indicator_width1  2

//---- indicator parameters
extern int Periods=20;
extern double SmoothConst=9;

//---- indicator buffers
double e0[];
double e1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,Periods);
   if(
   	!SetIndexBuffer(0,e0) &&
      !SetIndexBuffer(1,e1) 
      )
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("VIDYA("+Periods+")");
//---- initialization done
   return(0);
   
  }
  
//+------------------------------------------------------------------+
//| Moving Average                                                   |
//+------------------------------------------------------------------+
int start()
  {
   int i,j,limit;
   double upday, downday;
   double CurrCl, PrevCl;
   double CMO;
   double SC;
   int counted_bars=IndicatorCounted();
   
//---- check for possible errors
   if(counted_bars<0) return(-1);
   
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
//   limit=Bars-Periods-1-counted_bars;
   limit=Bars-counted_bars;

//---- main loop
   for(i=limit; i>=0; i--) 
   {
     upday = 0;
     downday = 0;
     for (j=0; j<Periods; j++)
     {
      CurrCl = Close[j];
      PrevCl = Close[j+1];
      if(CurrCl > PrevCl) upday = upday + (CurrCl - PrevCl);
      if(CurrCl <= PrevCl) downday = downday + (PrevCl - CurrCl);
     }
   	CMO =100*((upday-downday)/(upday+downday));
   	SC = 2/(SmoothConst+1);
      e1[i] = MathAbs(CMO)/100;
//      e0[i]= SC*e1[i]*Close[i] + (1-SC*e1[i])*Close[i+1]; 
      e0[i]= SC*e1[i]*Close[i] + (1-SC*e1[i])*e0[i+1]; 
   }
//---- done
   return(0);
  }
  
//+------------------------------------------------------------------+

